const cp = require('child_process')
const fs = require('fs')
const path = require('path')
const userhome = require('user-home')
const { Spinner } = require('cli-spinner');

function spinnerStart(info) {
  const spinner = new Spinner(`${info} %s`);
  spinner.setSpinnerString("|/-\\");
  spinner.start();
  return spinner
}

async function execLink() {
  const pkg = fs.readFileSync(path.resolve(__dirname, 'package.json'))
  const templatesPath = path.resolve(userhome, '.lin-cli', 'templates')
  const spin = spinnerStart('正在创建软连接')
  await spawn("cmd", ["/c", "npm link"])
  await spawn("cmd", ["/c", `cd /D ${templatesPath} && npm link ${JSON.parse(pkg).name}`])
  spin.stop(true)
  console.info('软连接建立成功！')
}

function spawn(cmd, args) {
  return new Promise(function(resolve, reject) {
    const child = cp.spawn(cmd, args)
    child.on('error', (err) => {
      reject(err)
    })
    child.on('exit', (exitCode, signal) => {
      resolve(exitCode)
    })
  })
}

(async () => {
  await execLink()
})()